package com.chinaitop.depot.product.service.impl;

import java.math.BigDecimal;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import com.chinaitop.depot.utils.JsonToObjectUtils;
import com.chinaitop.depot.utils.ParameterUtil;
import org.springframework.stereotype.Service;

import com.chinaitop.depot.feign.BasicFeignClient;
import com.chinaitop.depot.product.mapper.StorageProductFcbgzMapper;
import com.chinaitop.depot.product.mapper.StorageProductKcslMapper;
import com.chinaitop.depot.product.model.StorageProductFcbgz;
import com.chinaitop.depot.product.model.StorageProductFcbgzExample;
import com.chinaitop.depot.product.service.StorageProductFcbgzService;
import com.chinaitop.depot.product.service.StorageProductKcslService;
import org.springframework.transaction.annotation.Transactional;

/**
 * @auther mafy
 * @createtime 2017/10/25 0025
 */
@Service
public class StorageProductFcbgzServiceImpl implements StorageProductFcbgzService {

    @Resource
    private StorageProductFcbgzMapper storageProductFcbgzMapper;

    @Resource
	private StorageProductKcslService storageProductKcslService;

    @Resource
    private StorageProductKcslMapper storageProductKcslMapper;

    @Resource
    private BasicFeignClient basicWarehouseFeignClient;

    @Override
    public List<StorageProductFcbgz> getlist(StorageProductFcbgzExample storageProductFcbgzExample) {
        return storageProductFcbgzMapper.selectByExample(storageProductFcbgzExample);
    }
    @Override
    public List<Map<String,Object>> getNumberList(Map<String,Object> map) {
        return storageProductFcbgzMapper.getNumberList(map);
    }
    @Override
    public List<Map<String,Object>> getProductHouse(Map<String,Object> map) {
        return storageProductFcbgzMapper.getProductHouse(map);
    }

    @Override
    public void insert(StorageProductFcbgz storageProductFcbgz) {
        storageProductFcbgzMapper.insertSelective(storageProductFcbgz);
    }

    @Override
    public void update(StorageProductFcbgz storageProductFcbgz) {
        storageProductFcbgzMapper.updateByPrimaryKeySelective(storageProductFcbgz);
    }

    @Override
    public void remove(String id) {
        StorageProductFcbgzExample example = new StorageProductFcbgzExample();
        StorageProductFcbgzExample.Criteria criteria = example.createCriteria();
        criteria.andIdEqualTo(id);

        StorageProductFcbgz storageProductFcbgz = new StorageProductFcbgz();
        storageProductFcbgz.setDeleteState("0");
        storageProductFcbgzMapper.updateByExampleSelective(storageProductFcbgz, example);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Map<String, String> edit(String productJson, Integer orgId, String typeState) throws Exception {
        Map<String,String> map = new HashMap<String, String>();
        StorageProductFcbgz storageProductFcbgz = (StorageProductFcbgz) JsonToObjectUtils.jsonToObject(productJson,"com.chinaitop.depot.product.model.StorageProductFcbgz");
        //如果是提交，则直接设置状态
        if(ParameterUtil.isequal("typeSubmit",typeState)){
            storageProductFcbgz.setDeleteState("2");
        } else {
            storageProductFcbgz.setDeleteState("1");
        }

        Date date = new Date();
        storageProductFcbgz.setUpdatetime(date);
        if(ParameterUtil.isnull(storageProductFcbgz.getStorageQuantity()))
            storageProductFcbgz.setStorageQuantity("0");
        if(ParameterUtil.isnull(storageProductFcbgz.getOutboundQuantity()))
            storageProductFcbgz.setOutboundQuantity("0");

        if(ParameterUtil.isnull(storageProductFcbgz.getId())){
            if(!ParameterUtil.isequal("numberData",typeState)) {
                double inventory = Double.parseDouble(storageProductFcbgz.getStorageQuantity()) - Double.parseDouble(storageProductFcbgz.getOutboundQuantity());
                storageProductFcbgz.setInventoryQuantity(new BigDecimal(inventory));
            }

            storageProductFcbgz.setOrgId(orgId);
            storageProductFcbgz.setId(ParameterUtil.getCode());
            storageProductFcbgz.setCreateTime(date);
            storageProductFcbgzMapper.insertSelective(storageProductFcbgz);
        }else{
            if(!ParameterUtil.isequal("numberData",typeState)) {
                double inventory = Double.parseDouble(storageProductFcbgz.getStorageQuantity()) - Double.parseDouble(storageProductFcbgz.getOutboundQuantity());
                storageProductFcbgz.setInventoryQuantity(new BigDecimal(inventory));
            }

            storageProductFcbgzMapper.updateByPrimaryKeySelective(storageProductFcbgz);
        }

        //如果是提交，那么要处理好库存的数据
        if(ParameterUtil.isequal("typeSubmit",typeState)) {
            map = storageProductKcslService.update(storageProductFcbgz, map);
        } else {
            map.put("status","success");
        }

        return map;
    }

    @Override
    public StorageProductFcbgz getProductById(String id) {
        return storageProductFcbgzMapper.selectByPrimaryKey(id);
    }

    @Override
    public void gitSubmit(StorageProductFcbgz storageProductFcbgz,StorageProductFcbgzExample storageProductFcbgzExample) {
        storageProductFcbgzMapper.updateByExampleSelective(storageProductFcbgz,storageProductFcbgzExample);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Map<String, String> getSubmit(String id) throws Exception {
        Map<String, String> map = new HashMap<String, String>();
        StorageProductFcbgz fcbgz = storageProductFcbgzMapper.selectByPrimaryKey(id);
        fcbgz.setDeleteState("2");
        storageProductFcbgzMapper.updateByPrimaryKeySelective(fcbgz);
        map.put("status","success");
        //提交后更新库存
        map = storageProductKcslService.update(fcbgz, map);
        return map;
    }

}
